#######################################################
#######################################################
############    COPYRIGHT - DATA SOCIETY   ############
#######################################################
#######################################################

################################
##       BASIC PLOTTING       ##
################################

## NOTE: To run individual pieces of code 
## select the line of code and press ctrl + enter for Windows
## and command + enter for Macs

#==================================================================================

# If you want to create some basic plots in R, you can use this code.
# It's a great way to quickly get some data plotted for initial visualizations

# 1. Create a scatter plot with x values from 5 to 25, and y as the equation 
#    3 * (x^2) - 5. Set the width to 5, color to green, and title as "Question 1 plot"

x = seq(5:25)
y = 3 * (x^2) - 5
plot(x, y,
     lwd = 5,       
     col = "green",
     main = "Question 1 plot")


# 2. Create a line plot with the same x and y variables. Label the x axis as 'x' and the
#    y axis as 'y'. Name the title "Question 2 plot", with a line width of 4 and color
#    black

x = seq(5:25)
y = 3 * (x^2) - 5
plot(x, y, 
     xlab = "x",     
     ylab = "y",     
     main = "Question 2 plot", 
     lwd = 4, 
     type = "l",     
     col = "black") 


# 3. Create a bar plot where x is between 0 and 15, y is x^3 + 20. Keep the x
#    and y axes labeled as 'x' and 'y', with the title as 'Question 3 plot',
#    and the bars should be purple. 

x = seq(0:15)
y = (x^3) + 20
barplot(height = y, 
        width = 1, 
        xlab = "x", 
        ylab = "y",
        main = "A barplot", 
        names.arg = x,           
        col = "purple") 


# 4. Create a data set called "Hist_Data" with the following numbers:
#    1, 1, 1, 1, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 5
#    Make the bars blue and label the graph "Question 4 histogram"


Hist_Data = c(rep(1, 4), rep(2, 2), rep(3, 6), rep(4, 3), rep(5, 1))
hist(Hist_Data,
     col = "blue",
     main = "Question 4 histogram",
     labels = TRUE, 
     breaks = 4)


# 5. Save the histogram to your computer as "Question 4 histogram"

dev.print(device = pdf, 
          "~/Desktop/Question 4 histogram.pdf")


# 6. Load the data set mtcars from the package 'datasets'

install.packages("datasets")
library(datasets)
View(mtcars)


# 7. Create a scatter plot that plots weight (wt) versus horsepower (hp). Label the 
#    axes as "Weight (in 1000 lbs)" and "Horsepower". The width should be 2, color
#    is blue, and the title should be "Weight vs Horsepower"

x = mtcars$wt
y = mtcars$hp
plot(x, y,
     xlab = "Weight (in 1000 lbs)",
     ylab = "Horsepower",
     lwd = 2, 
     col = "blue",
     main = "Weight vs Horsepower")


# 8. Visualize the same data above as a line graph

x = mtcars$wt
y = mtcars$hp
plot(x, y, 
     xlab = "Weight (in 1000 lbs)",   
     ylab = "Horsepower",     
     main = "Weight vs Horsepower", 
     lwd = 2, 
     type = "l",     
     col = "blue") 


# 9. Order the data by weight and replot the line graph. Name the new data set as
#    "mtcars.wtorder


mtcars.wtorder = mtcars[order(mtcars$wt, decreasing = F),]
View(mtcars.wtorder)

x = mtcars.wtorder$wt
y = mtcars.wtorder$hp
plot(x, y, 
     xlab = "Weight (in 1000 lbs)",   
     ylab = "Horsepower",     
     main = "Weight vs Horsepower", 
     lwd = 2, 
     type = "l",     
     col = "blue") 


# 10. Create a histogram that plots the number of cylinders (cyl). Label the 
#     x axis as "Cylinders" and y axis as "Count, with the title "Number of 
#     cylinders in cars". What does the graph look like with 2 breaks and red
#     columns?

x = mtcars.wtorder$cyl
hist(x,
     col = "red",
     xlab = "Cylinders",   
     ylab = "Count",     
     main = "Number of cylinders in cars",  
     breaks = 2) 


# 11. What if we use the same data as in Question 10, but create 4 breaks with
#     black columns and white borders?

x = mtcars.order$cyl
hist(x,
     col = "black",
     border = "white",
     xlab = "Cylinders",   
     ylab = "Count",     
     main = "Number of cylinders in cars",  
     breaks = 4) 


# 12. Why is it difficult to represent data accurately with the hist() function?

# Because some of the bars include more than one category, so it's difficult to 
# get a good idea of the data set without understanding what data each bar
# represents.


# Continue to practice these operations until you feel
# comfortable in R. The only way to become truly
# proficient is to spend time coding!
